# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.1

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

try:
    import winsdk.windows.graphics
except Exception:
    pass

try:
    import winsdk.windows.graphics.directx.direct3d11
except Exception:
    pass

try:
    import winsdk.windows.graphics.imaging
except Exception:
    pass

try:
    import winsdk.windows.media
except Exception:
    pass

try:
    import winsdk.windows.storage
except Exception:
    pass

try:
    import winsdk.windows.storage.streams
except Exception:
    pass

class LearningModelDeviceKind(enum.IntEnum):
    DEFAULT = 0
    CPU = 1
    DIRECT_X = 2
    DIRECT_X_HIGH_PERFORMANCE = 3
    DIRECT_X_MIN_POWER = 4

class LearningModelFeatureKind(enum.IntEnum):
    TENSOR = 0
    SEQUENCE = 1
    MAP = 2
    IMAGE = 3

class LearningModelPixelRange(enum.IntEnum):
    ZERO_TO255 = 0
    ZERO_TO_ONE = 1
    MINUS_ONE_TO_ONE = 2

class TensorKind(enum.IntEnum):
    UNDEFINED = 0
    FLOAT = 1
    UINT8 = 2
    INT8 = 3
    UINT16 = 4
    INT16 = 5
    INT32 = 6
    INT64 = 7
    STRING = 8
    BOOLEAN = 9
    FLOAT16 = 10
    DOUBLE = 11
    UINT32 = 12
    UINT64 = 13
    COMPLEX64 = 14
    COMPLEX128 = 15

class ImageFeatureDescriptor(ILearningModelFeatureDescriptor, _winrt.Object):
    ...
    bitmap_alpha_mode: winsdk.windows.graphics.imaging.BitmapAlphaMode
    bitmap_pixel_format: winsdk.windows.graphics.imaging.BitmapPixelFormat
    height: _winrt.UInt32
    width: _winrt.UInt32
    pixel_range: LearningModelPixelRange
    description: str
    is_required: _winrt.Boolean
    kind: LearningModelFeatureKind
    name: str

class ImageFeatureValue(ILearningModelFeatureValue, _winrt.Object):
    ...
    video_frame: winsdk.windows.media.VideoFrame
    kind: LearningModelFeatureKind
    def create_from_video_frame(image: winsdk.windows.media.VideoFrame) -> ImageFeatureValue:
        ...

class LearningModel(winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    author: str
    description: str
    domain: str
    input_features: winsdk.windows.foundation.collections.IVectorView[ILearningModelFeatureDescriptor]
    metadata: winsdk.windows.foundation.collections.IMapView[str, str]
    name: str
    output_features: winsdk.windows.foundation.collections.IVectorView[ILearningModelFeatureDescriptor]
    version: _winrt.Int64
    def close() -> None:
        ...
    def load_from_file_path(file_path: str) -> LearningModel:
        ...
    def load_from_file_path(file_path: str, operator_provider: ILearningModelOperatorProvider) -> LearningModel:
        ...
    def load_from_storage_file_async(model_file: winsdk.windows.storage.IStorageFile) -> winsdk.windows.foundation.IAsyncOperation[LearningModel]:
        ...
    def load_from_storage_file_async(model_file: winsdk.windows.storage.IStorageFile, operator_provider: ILearningModelOperatorProvider) -> winsdk.windows.foundation.IAsyncOperation[LearningModel]:
        ...
    def load_from_stream(model_stream: winsdk.windows.storage.streams.IRandomAccessStreamReference) -> LearningModel:
        ...
    def load_from_stream(model_stream: winsdk.windows.storage.streams.IRandomAccessStreamReference, operator_provider: ILearningModelOperatorProvider) -> LearningModel:
        ...
    def load_from_stream_async(model_stream: winsdk.windows.storage.streams.IRandomAccessStreamReference) -> winsdk.windows.foundation.IAsyncOperation[LearningModel]:
        ...
    def load_from_stream_async(model_stream: winsdk.windows.storage.streams.IRandomAccessStreamReference, operator_provider: ILearningModelOperatorProvider) -> winsdk.windows.foundation.IAsyncOperation[LearningModel]:
        ...

class LearningModelBinding(winsdk.windows.foundation.collections.IMapView[str, _winrt.Object], winsdk.windows.foundation.collections.IIterable[winsdk.windows.foundation.collections.IKeyValuePair[str, _winrt.Object]], _winrt.Object):
    ...
    size: _winrt.UInt32
    def __init__(self, session: LearningModelSession) -> None:
        ...
    def bind(name: str, value: _winrt.Object) -> None:
        ...
    def bind(name: str, value: _winrt.Object, props: winsdk.windows.foundation.collections.IPropertySet) -> None:
        ...
    def clear() -> None:
        ...
    def first() -> winsdk.windows.foundation.collections.IIterator[winsdk.windows.foundation.collections.IKeyValuePair[str, _winrt.Object]]:
        ...
    def has_key(key: str) -> _winrt.Boolean:
        ...
    def lookup(key: str) -> _winrt.Object:
        ...
    def split() -> typing.Tuple[winsdk.windows.foundation.collections.IMapView[str, _winrt.Object], winsdk.windows.foundation.collections.IMapView[str, _winrt.Object]]:
        ...

class LearningModelDevice(_winrt.Object):
    ...
    adapter_id: winsdk.windows.graphics.DisplayAdapterId
    direct3_d11_device: winsdk.windows.graphics.directx.direct3d11.IDirect3DDevice
    def __init__(self, device_kind: LearningModelDeviceKind) -> None:
        ...
    def create_from_direct3_d11_device(device: winsdk.windows.graphics.directx.direct3d11.IDirect3DDevice) -> LearningModelDevice:
        ...

class LearningModelEvaluationResult(_winrt.Object):
    ...
    correlation_id: str
    error_status: _winrt.Int32
    outputs: winsdk.windows.foundation.collections.IMapView[str, _winrt.Object]
    succeeded: _winrt.Boolean

class LearningModelSession(winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    device: LearningModelDevice
    evaluation_properties: winsdk.windows.foundation.collections.IPropertySet
    model: LearningModel
    def __init__(self, model: LearningModel, device_to_run_on: LearningModelDevice, learning_model_session_options: LearningModelSessionOptions) -> None:
        ...
    def __init__(self, model: LearningModel) -> None:
        ...
    def __init__(self, model: LearningModel, device_to_run_on: LearningModelDevice) -> None:
        ...
    def close() -> None:
        ...
    def evaluate(bindings: LearningModelBinding, correlation_id: str) -> LearningModelEvaluationResult:
        ...
    def evaluate_async(bindings: LearningModelBinding, correlation_id: str) -> winsdk.windows.foundation.IAsyncOperation[LearningModelEvaluationResult]:
        ...
    def evaluate_features(features: winsdk.windows.foundation.collections.IMap[str, _winrt.Object], correlation_id: str) -> LearningModelEvaluationResult:
        ...
    def evaluate_features_async(features: winsdk.windows.foundation.collections.IMap[str, _winrt.Object], correlation_id: str) -> winsdk.windows.foundation.IAsyncOperation[LearningModelEvaluationResult]:
        ...

class LearningModelSessionOptions(_winrt.Object):
    ...
    batch_size_override: _winrt.UInt32
    close_model_on_session_creation: _winrt.Boolean
    def __init__(self, ) -> None:
        ...
    def override_named_dimension(name: str, dimension: _winrt.UInt32) -> None:
        ...

class MapFeatureDescriptor(ILearningModelFeatureDescriptor, _winrt.Object):
    ...
    description: str
    is_required: _winrt.Boolean
    kind: LearningModelFeatureKind
    name: str
    key_kind: TensorKind
    value_descriptor: ILearningModelFeatureDescriptor

class SequenceFeatureDescriptor(ILearningModelFeatureDescriptor, _winrt.Object):
    ...
    description: str
    is_required: _winrt.Boolean
    kind: LearningModelFeatureKind
    name: str
    element_descriptor: ILearningModelFeatureDescriptor

class TensorBoolean(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorBoolean:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorBoolean:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Boolean]) -> TensorBoolean:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorBoolean:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Boolean]) -> TensorBoolean:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Boolean]) -> TensorBoolean:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Boolean]:
        ...

class TensorDouble(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorDouble:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorDouble:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Double]) -> TensorDouble:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorDouble:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Double]) -> TensorDouble:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Double]) -> TensorDouble:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Double]:
        ...

class TensorFeatureDescriptor(ILearningModelFeatureDescriptor, _winrt.Object):
    ...
    description: str
    is_required: _winrt.Boolean
    kind: LearningModelFeatureKind
    name: str
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind

class TensorFloat(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorFloat:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorFloat:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Single]) -> TensorFloat:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorFloat:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Single]) -> TensorFloat:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Single]) -> TensorFloat:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Single]:
        ...

class TensorFloat16Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorFloat16Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorFloat16Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Single]) -> TensorFloat16Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorFloat16Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Single]) -> TensorFloat16Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Single]) -> TensorFloat16Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Single]:
        ...

class TensorInt16Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorInt16Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorInt16Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Int16]) -> TensorInt16Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorInt16Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Int16]) -> TensorInt16Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Int16]) -> TensorInt16Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Int16]:
        ...

class TensorInt32Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorInt32Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorInt32Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Int32]) -> TensorInt32Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorInt32Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Int32]) -> TensorInt32Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Int32]) -> TensorInt32Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Int32]:
        ...

class TensorInt64Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorInt64Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorInt64Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.Int64]) -> TensorInt64Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorInt64Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.Int64]) -> TensorInt64Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.Int64]) -> TensorInt64Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]:
        ...

class TensorInt8Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorInt8Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorInt8Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.UInt8]) -> TensorInt8Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorInt8Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.UInt8]) -> TensorInt8Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.UInt8]) -> TensorInt8Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.UInt8]:
        ...

class TensorString(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorString:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorString:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[str]) -> TensorString:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[str]) -> TensorString:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[str]) -> TensorString:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[str]:
        ...

class TensorUInt16Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorUInt16Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorUInt16Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.UInt16]) -> TensorUInt16Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorUInt16Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.UInt16]) -> TensorUInt16Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.UInt16]) -> TensorUInt16Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.UInt16]:
        ...

class TensorUInt32Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorUInt32Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorUInt32Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.UInt32]) -> TensorUInt32Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorUInt32Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.UInt32]) -> TensorUInt32Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.UInt32]) -> TensorUInt32Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.UInt32]:
        ...

class TensorUInt64Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorUInt64Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorUInt64Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.UInt64]) -> TensorUInt64Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorUInt64Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.UInt64]) -> TensorUInt64Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.UInt64]) -> TensorUInt64Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.UInt64]:
        ...

class TensorUInt8Bit(ITensor, ILearningModelFeatureValue, winsdk.windows.foundation.IMemoryBuffer, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    kind: LearningModelFeatureKind
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    def close() -> None:
        ...
    def create() -> TensorUInt8Bit:
        ...
    def create(shape: typing.Iterable[_winrt.Int64]) -> TensorUInt8Bit:
        ...
    def create_from_array(shape: typing.Iterable[_winrt.Int64], data: typing.Sequence[_winrt.UInt8]) -> TensorUInt8Bit:
        ...
    def create_from_buffer(shape: typing.Sequence[_winrt.Int64], buffer: winsdk.windows.storage.streams.IBuffer) -> TensorUInt8Bit:
        ...
    def create_from_iterable(shape: typing.Iterable[_winrt.Int64], data: typing.Iterable[_winrt.UInt8]) -> TensorUInt8Bit:
        ...
    def create_from_shape_array_and_data_array(shape: typing.Sequence[_winrt.Int64], data: typing.Sequence[_winrt.UInt8]) -> TensorUInt8Bit:
        ...
    def create_reference() -> winsdk.windows.foundation.IMemoryBufferReference:
        ...
    def get_as_vector_view() -> winsdk.windows.foundation.collections.IVectorView[_winrt.UInt8]:
        ...

class ILearningModelFeatureDescriptor(_winrt.Object):
    ...
    description: str
    is_required: _winrt.Boolean
    kind: LearningModelFeatureKind
    name: str

class ILearningModelFeatureValue(_winrt.Object):
    ...
    kind: LearningModelFeatureKind

class ILearningModelOperatorProvider(_winrt.Object):
    ...

class ITensor(ILearningModelFeatureValue, _winrt.Object):
    ...
    shape: winsdk.windows.foundation.collections.IVectorView[_winrt.Int64]
    tensor_kind: TensorKind
    kind: LearningModelFeatureKind

