# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.1

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.devices.enumeration
except Exception:
    pass

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.storage.streams
except Exception:
    pass

class MidiMessageType(enum.IntEnum):
    NONE = 0
    NOTE_OFF = 128
    NOTE_ON = 144
    POLYPHONIC_KEY_PRESSURE = 160
    CONTROL_CHANGE = 176
    PROGRAM_CHANGE = 192
    CHANNEL_PRESSURE = 208
    PITCH_BEND_CHANGE = 224
    SYSTEM_EXCLUSIVE = 240
    MIDI_TIME_CODE = 241
    SONG_POSITION_POINTER = 242
    SONG_SELECT = 243
    TUNE_REQUEST = 246
    END_SYSTEM_EXCLUSIVE = 247
    TIMING_CLOCK = 248
    START = 250
    CONTINUE = 251
    STOP = 252
    ACTIVE_SENSING = 254
    SYSTEM_RESET = 255

class MidiActiveSensingMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class MidiChannelPressureMessage(IMidiMessage, _winrt.Object):
    ...
    channel: _winrt.UInt8
    pressure: _winrt.UInt8
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, channel: _winrt.UInt8, pressure: _winrt.UInt8) -> None:
        ...

class MidiContinueMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class MidiControlChangeMessage(IMidiMessage, _winrt.Object):
    ...
    channel: _winrt.UInt8
    control_value: _winrt.UInt8
    controller: _winrt.UInt8
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, channel: _winrt.UInt8, controller: _winrt.UInt8, control_value: _winrt.UInt8) -> None:
        ...

class MidiInPort(winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    device_id: str
    def close() -> None:
        ...
    def from_id_async(device_id: str) -> winsdk.windows.foundation.IAsyncOperation[MidiInPort]:
        ...
    def get_device_selector() -> str:
        ...
    def add_message_received(handler: winsdk.windows.foundation.TypedEventHandler[MidiInPort, MidiMessageReceivedEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken:
        ...
    def remove_message_received(token: winsdk.windows.foundation.EventRegistrationToken) -> None:
        ...

class MidiMessageReceivedEventArgs(_winrt.Object):
    ...
    message: IMidiMessage

class MidiNoteOffMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    channel: _winrt.UInt8
    note: _winrt.UInt8
    velocity: _winrt.UInt8
    def __init__(self, channel: _winrt.UInt8, note: _winrt.UInt8, velocity: _winrt.UInt8) -> None:
        ...

class MidiNoteOnMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    channel: _winrt.UInt8
    note: _winrt.UInt8
    velocity: _winrt.UInt8
    def __init__(self, channel: _winrt.UInt8, note: _winrt.UInt8, velocity: _winrt.UInt8) -> None:
        ...

class MidiOutPort(IMidiOutPort, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    device_id: str
    def close() -> None:
        ...
    def from_id_async(device_id: str) -> winsdk.windows.foundation.IAsyncOperation[IMidiOutPort]:
        ...
    def get_device_selector() -> str:
        ...
    def send_buffer(midi_data: winsdk.windows.storage.streams.IBuffer) -> None:
        ...
    def send_message(midi_message: IMidiMessage) -> None:
        ...

class MidiPitchBendChangeMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    bend: _winrt.UInt16
    channel: _winrt.UInt8
    def __init__(self, channel: _winrt.UInt8, bend: _winrt.UInt16) -> None:
        ...

class MidiPolyphonicKeyPressureMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    channel: _winrt.UInt8
    note: _winrt.UInt8
    pressure: _winrt.UInt8
    def __init__(self, channel: _winrt.UInt8, note: _winrt.UInt8, pressure: _winrt.UInt8) -> None:
        ...

class MidiProgramChangeMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    channel: _winrt.UInt8
    program: _winrt.UInt8
    def __init__(self, channel: _winrt.UInt8, program: _winrt.UInt8) -> None:
        ...

class MidiSongPositionPointerMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    beats: _winrt.UInt16
    def __init__(self, beats: _winrt.UInt16) -> None:
        ...

class MidiSongSelectMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    song: _winrt.UInt8
    def __init__(self, song: _winrt.UInt8) -> None:
        ...

class MidiStartMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class MidiStopMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class MidiSynthesizer(IMidiOutPort, winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    device_id: str
    volume: _winrt.Double
    audio_device: winsdk.windows.devices.enumeration.DeviceInformation
    def close() -> None:
        ...
    def create_async() -> winsdk.windows.foundation.IAsyncOperation[MidiSynthesizer]:
        ...
    def create_async(audio_device: winsdk.windows.devices.enumeration.DeviceInformation) -> winsdk.windows.foundation.IAsyncOperation[MidiSynthesizer]:
        ...
    def is_synthesizer(midi_device: winsdk.windows.devices.enumeration.DeviceInformation) -> _winrt.Boolean:
        ...
    def send_buffer(midi_data: winsdk.windows.storage.streams.IBuffer) -> None:
        ...
    def send_message(midi_message: IMidiMessage) -> None:
        ...

class MidiSystemExclusiveMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, raw_data: winsdk.windows.storage.streams.IBuffer) -> None:
        ...

class MidiSystemResetMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class MidiTimeCodeMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    frame_type: _winrt.UInt8
    values: _winrt.UInt8
    def __init__(self, frame_type: _winrt.UInt8, values: _winrt.UInt8) -> None:
        ...

class MidiTimingClockMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class MidiTuneRequestMessage(IMidiMessage, _winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType
    def __init__(self, ) -> None:
        ...

class IMidiMessage(_winrt.Object):
    ...
    raw_data: winsdk.windows.storage.streams.IBuffer
    timestamp: winsdk.windows.foundation.TimeSpan
    type: MidiMessageType

class IMidiOutPort(winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    device_id: str
    def send_buffer(midi_data: winsdk.windows.storage.streams.IBuffer) -> None:
        ...
    def send_message(midi_message: IMidiMessage) -> None:
        ...
    def close() -> None:
        ...

