# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.1

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

try:
    import winsdk.windows.storage.streams
except Exception:
    pass

class UsbControlRecipient(enum.IntEnum):
    DEVICE = 0
    SPECIFIED_INTERFACE = 1
    ENDPOINT = 2
    OTHER = 3
    DEFAULT_INTERFACE = 4

class UsbControlTransferType(enum.IntEnum):
    STANDARD = 0
    CLASS = 1
    VENDOR = 2

class UsbEndpointType(enum.IntEnum):
    CONTROL = 0
    ISOCHRONOUS = 1
    BULK = 2
    INTERRUPT = 3

class UsbReadOptions(enum.IntFlag):
    NONE = 0
    AUTO_CLEAR_STALL = 0x1
    OVERRIDE_AUTOMATIC_BUFFER_MANAGEMENT = 0x2
    IGNORE_SHORT_PACKET = 0x4
    ALLOW_PARTIAL_READS = 0x8

class UsbTransferDirection(enum.IntEnum):
    OUT = 0
    IN = 1

class UsbWriteOptions(enum.IntFlag):
    NONE = 0
    AUTO_CLEAR_STALL = 0x1
    SHORT_PACKET_TERMINATE = 0x2

class UsbBulkInEndpointDescriptor(_winrt.Object):
    ...
    endpoint_number: _winrt.UInt8
    max_packet_size: _winrt.UInt32
    pipe: UsbBulkInPipe

class UsbBulkInPipe(_winrt.Object):
    ...
    read_options: UsbReadOptions
    endpoint_descriptor: UsbBulkInEndpointDescriptor
    input_stream: winsdk.windows.storage.streams.IInputStream
    max_transfer_size_bytes: _winrt.UInt32
    def clear_stall_async() -> winsdk.windows.foundation.IAsyncAction:
        ...
    def flush_buffer() -> None:
        ...

class UsbBulkOutEndpointDescriptor(_winrt.Object):
    ...
    endpoint_number: _winrt.UInt8
    max_packet_size: _winrt.UInt32
    pipe: UsbBulkOutPipe

class UsbBulkOutPipe(_winrt.Object):
    ...
    write_options: UsbWriteOptions
    endpoint_descriptor: UsbBulkOutEndpointDescriptor
    output_stream: winsdk.windows.storage.streams.IOutputStream
    def clear_stall_async() -> winsdk.windows.foundation.IAsyncAction:
        ...

class UsbConfiguration(_winrt.Object):
    ...
    configuration_descriptor: UsbConfigurationDescriptor
    descriptors: winsdk.windows.foundation.collections.IVectorView[UsbDescriptor]
    usb_interfaces: winsdk.windows.foundation.collections.IVectorView[UsbInterface]

class UsbConfigurationDescriptor(_winrt.Object):
    ...
    configuration_value: _winrt.UInt8
    max_power_milliamps: _winrt.UInt32
    remote_wakeup: _winrt.Boolean
    self_powered: _winrt.Boolean
    def parse(descriptor: UsbDescriptor) -> UsbConfigurationDescriptor:
        ...
    def try_parse(descriptor: UsbDescriptor) -> typing.Tuple[_winrt.Boolean, UsbConfigurationDescriptor]:
        ...

class UsbControlRequestType(_winrt.Object):
    ...
    recipient: UsbControlRecipient
    direction: UsbTransferDirection
    control_transfer_type: UsbControlTransferType
    as_byte: _winrt.UInt8
    def __init__(self, ) -> None:
        ...

class UsbDescriptor(_winrt.Object):
    ...
    descriptor_type: _winrt.UInt8
    length: _winrt.UInt8
    def read_descriptor_buffer(buffer: winsdk.windows.storage.streams.IBuffer) -> None:
        ...

class UsbDevice(winsdk.windows.foundation.IClosable, _winrt.Object):
    ...
    configuration: UsbConfiguration
    default_interface: UsbInterface
    device_descriptor: UsbDeviceDescriptor
    def close() -> None:
        ...
    def from_id_async(device_id: str) -> winsdk.windows.foundation.IAsyncOperation[UsbDevice]:
        ...
    def get_device_class_selector(usb_class: UsbDeviceClass) -> str:
        ...
    def get_device_selector(win_usb_interface_class: uuid.UUID) -> str:
        ...
    def get_device_selector(vendor_id: _winrt.UInt32, product_id: _winrt.UInt32) -> str:
        ...
    def get_device_selector(vendor_id: _winrt.UInt32, product_id: _winrt.UInt32, win_usb_interface_class: uuid.UUID) -> str:
        ...
    def send_control_in_transfer_async(setup_packet: UsbSetupPacket) -> winsdk.windows.foundation.IAsyncOperation[winsdk.windows.storage.streams.IBuffer]:
        ...
    def send_control_in_transfer_async(setup_packet: UsbSetupPacket, buffer: winsdk.windows.storage.streams.IBuffer) -> winsdk.windows.foundation.IAsyncOperation[winsdk.windows.storage.streams.IBuffer]:
        ...
    def send_control_out_transfer_async(setup_packet: UsbSetupPacket) -> winsdk.windows.foundation.IAsyncOperation[_winrt.UInt32]:
        ...
    def send_control_out_transfer_async(setup_packet: UsbSetupPacket, buffer: winsdk.windows.storage.streams.IBuffer) -> winsdk.windows.foundation.IAsyncOperation[_winrt.UInt32]:
        ...

class UsbDeviceClass(_winrt.Object):
    ...
    subclass_code: typing.Optional[_winrt.UInt8]
    protocol_code: typing.Optional[_winrt.UInt8]
    class_code: _winrt.UInt8
    def __init__(self, ) -> None:
        ...

class UsbDeviceClasses(_winrt.Object):
    ...
    active_sync: UsbDeviceClass
    cdc_control: UsbDeviceClass
    device_firmware_update: UsbDeviceClass
    irda: UsbDeviceClass
    measurement: UsbDeviceClass
    palm_sync: UsbDeviceClass
    personal_healthcare: UsbDeviceClass
    physical: UsbDeviceClass
    vendor_specific: UsbDeviceClass

class UsbDeviceDescriptor(_winrt.Object):
    ...
    bcd_device_revision: _winrt.UInt32
    bcd_usb: _winrt.UInt32
    max_packet_size0: _winrt.UInt8
    number_of_configurations: _winrt.UInt8
    product_id: _winrt.UInt32
    vendor_id: _winrt.UInt32

class UsbEndpointDescriptor(_winrt.Object):
    ...
    as_bulk_in_endpoint_descriptor: UsbBulkInEndpointDescriptor
    as_bulk_out_endpoint_descriptor: UsbBulkOutEndpointDescriptor
    as_interrupt_in_endpoint_descriptor: UsbInterruptInEndpointDescriptor
    as_interrupt_out_endpoint_descriptor: UsbInterruptOutEndpointDescriptor
    direction: UsbTransferDirection
    endpoint_number: _winrt.UInt8
    endpoint_type: UsbEndpointType
    def parse(descriptor: UsbDescriptor) -> UsbEndpointDescriptor:
        ...
    def try_parse(descriptor: UsbDescriptor) -> typing.Tuple[_winrt.Boolean, UsbEndpointDescriptor]:
        ...

class UsbInterface(_winrt.Object):
    ...
    bulk_in_pipes: winsdk.windows.foundation.collections.IVectorView[UsbBulkInPipe]
    bulk_out_pipes: winsdk.windows.foundation.collections.IVectorView[UsbBulkOutPipe]
    descriptors: winsdk.windows.foundation.collections.IVectorView[UsbDescriptor]
    interface_number: _winrt.UInt8
    interface_settings: winsdk.windows.foundation.collections.IVectorView[UsbInterfaceSetting]
    interrupt_in_pipes: winsdk.windows.foundation.collections.IVectorView[UsbInterruptInPipe]
    interrupt_out_pipes: winsdk.windows.foundation.collections.IVectorView[UsbInterruptOutPipe]

class UsbInterfaceDescriptor(_winrt.Object):
    ...
    alternate_setting_number: _winrt.UInt8
    class_code: _winrt.UInt8
    interface_number: _winrt.UInt8
    protocol_code: _winrt.UInt8
    subclass_code: _winrt.UInt8
    def parse(descriptor: UsbDescriptor) -> UsbInterfaceDescriptor:
        ...
    def try_parse(descriptor: UsbDescriptor) -> typing.Tuple[_winrt.Boolean, UsbInterfaceDescriptor]:
        ...

class UsbInterfaceSetting(_winrt.Object):
    ...
    bulk_in_endpoints: winsdk.windows.foundation.collections.IVectorView[UsbBulkInEndpointDescriptor]
    bulk_out_endpoints: winsdk.windows.foundation.collections.IVectorView[UsbBulkOutEndpointDescriptor]
    descriptors: winsdk.windows.foundation.collections.IVectorView[UsbDescriptor]
    interface_descriptor: UsbInterfaceDescriptor
    interrupt_in_endpoints: winsdk.windows.foundation.collections.IVectorView[UsbInterruptInEndpointDescriptor]
    interrupt_out_endpoints: winsdk.windows.foundation.collections.IVectorView[UsbInterruptOutEndpointDescriptor]
    selected: _winrt.Boolean
    def select_setting_async() -> winsdk.windows.foundation.IAsyncAction:
        ...

class UsbInterruptInEndpointDescriptor(_winrt.Object):
    ...
    endpoint_number: _winrt.UInt8
    interval: winsdk.windows.foundation.TimeSpan
    max_packet_size: _winrt.UInt32
    pipe: UsbInterruptInPipe

class UsbInterruptInEventArgs(_winrt.Object):
    ...
    interrupt_data: winsdk.windows.storage.streams.IBuffer

class UsbInterruptInPipe(_winrt.Object):
    ...
    endpoint_descriptor: UsbInterruptInEndpointDescriptor
    def clear_stall_async() -> winsdk.windows.foundation.IAsyncAction:
        ...
    def add_data_received(handler: winsdk.windows.foundation.TypedEventHandler[UsbInterruptInPipe, UsbInterruptInEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken:
        ...
    def remove_data_received(token: winsdk.windows.foundation.EventRegistrationToken) -> None:
        ...

class UsbInterruptOutEndpointDescriptor(_winrt.Object):
    ...
    endpoint_number: _winrt.UInt8
    interval: winsdk.windows.foundation.TimeSpan
    max_packet_size: _winrt.UInt32
    pipe: UsbInterruptOutPipe

class UsbInterruptOutPipe(_winrt.Object):
    ...
    write_options: UsbWriteOptions
    endpoint_descriptor: UsbInterruptOutEndpointDescriptor
    output_stream: winsdk.windows.storage.streams.IOutputStream
    def clear_stall_async() -> winsdk.windows.foundation.IAsyncAction:
        ...

class UsbSetupPacket(_winrt.Object):
    ...
    value: _winrt.UInt32
    request_type: UsbControlRequestType
    request: _winrt.UInt8
    length: _winrt.UInt32
    index: _winrt.UInt32
    def __init__(self, eight_byte_buffer: winsdk.windows.storage.streams.IBuffer) -> None:
        ...
    def __init__(self, ) -> None:
        ...

