# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.1

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

try:
    import winsdk.windows.networking.connectivity
except Exception:
    pass

try:
    import winsdk.windows.security.credentials
except Exception:
    pass

class WiFiAccessStatus(enum.IntEnum):
    UNSPECIFIED = 0
    ALLOWED = 1
    DENIED_BY_USER = 2
    DENIED_BY_SYSTEM = 3

class WiFiConnectionMethod(enum.IntEnum):
    DEFAULT = 0
    WPS_PIN = 1
    WPS_PUSH_BUTTON = 2

class WiFiConnectionStatus(enum.IntEnum):
    UNSPECIFIED_FAILURE = 0
    SUCCESS = 1
    ACCESS_REVOKED = 2
    INVALID_CREDENTIAL = 3
    NETWORK_NOT_AVAILABLE = 4
    TIMEOUT = 5
    UNSUPPORTED_AUTHENTICATION_PROTOCOL = 6

class WiFiNetworkKind(enum.IntEnum):
    ANY = 0
    INFRASTRUCTURE = 1
    ADHOC = 2

class WiFiPhyKind(enum.IntEnum):
    UNKNOWN = 0
    FHSS = 1
    DSSS = 2
    I_R_BASEBAND = 3
    OFDM = 4
    HRDSSS = 5
    ERP = 6
    H_T = 7
    VHT = 8
    DMG = 9
    H_E = 10

class WiFiReconnectionKind(enum.IntEnum):
    AUTOMATIC = 0
    MANUAL = 1

class WiFiWpsConfigurationStatus(enum.IntEnum):
    UNSPECIFIED_FAILURE = 0
    SUCCESS = 1
    TIMEOUT = 2

class WiFiWpsKind(enum.IntEnum):
    UNKNOWN = 0
    PIN = 1
    PUSH_BUTTON = 2
    NFC = 3
    ETHERNET = 4
    USB = 5

class WiFiAdapter(_winrt.Object):
    ...
    network_adapter: winsdk.windows.networking.connectivity.NetworkAdapter
    network_report: WiFiNetworkReport
    def connect_async(available_network: WiFiAvailableNetwork, reconnection_kind: WiFiReconnectionKind) -> winsdk.windows.foundation.IAsyncOperation[WiFiConnectionResult]:
        ...
    def connect_async(available_network: WiFiAvailableNetwork, reconnection_kind: WiFiReconnectionKind, password_credential: winsdk.windows.security.credentials.PasswordCredential) -> winsdk.windows.foundation.IAsyncOperation[WiFiConnectionResult]:
        ...
    def connect_async(available_network: WiFiAvailableNetwork, reconnection_kind: WiFiReconnectionKind, password_credential: winsdk.windows.security.credentials.PasswordCredential, ssid: str) -> winsdk.windows.foundation.IAsyncOperation[WiFiConnectionResult]:
        ...
    def connect_async(available_network: WiFiAvailableNetwork, reconnection_kind: WiFiReconnectionKind, password_credential: winsdk.windows.security.credentials.PasswordCredential, ssid: str, connection_method: WiFiConnectionMethod) -> winsdk.windows.foundation.IAsyncOperation[WiFiConnectionResult]:
        ...
    def disconnect() -> None:
        ...
    def find_all_adapters_async() -> winsdk.windows.foundation.IAsyncOperation[winsdk.windows.foundation.collections.IVectorView[WiFiAdapter]]:
        ...
    def from_id_async(device_id: str) -> winsdk.windows.foundation.IAsyncOperation[WiFiAdapter]:
        ...
    def get_device_selector() -> str:
        ...
    def get_wps_configuration_async(available_network: WiFiAvailableNetwork) -> winsdk.windows.foundation.IAsyncOperation[WiFiWpsConfigurationResult]:
        ...
    def request_access_async() -> winsdk.windows.foundation.IAsyncOperation[WiFiAccessStatus]:
        ...
    def scan_async() -> winsdk.windows.foundation.IAsyncAction:
        ...
    def add_available_networks_changed(args: winsdk.windows.foundation.TypedEventHandler[WiFiAdapter, _winrt.Object]) -> winsdk.windows.foundation.EventRegistrationToken:
        ...
    def remove_available_networks_changed(event_cookie: winsdk.windows.foundation.EventRegistrationToken) -> None:
        ...

class WiFiAvailableNetwork(_winrt.Object):
    ...
    beacon_interval: winsdk.windows.foundation.TimeSpan
    bssid: str
    channel_center_frequency_in_kilohertz: _winrt.Int32
    is_wi_fi_direct: _winrt.Boolean
    network_kind: WiFiNetworkKind
    network_rssi_in_decibel_milliwatts: _winrt.Double
    phy_kind: WiFiPhyKind
    security_settings: winsdk.windows.networking.connectivity.NetworkSecuritySettings
    signal_bars: _winrt.UInt8
    ssid: str
    uptime: winsdk.windows.foundation.TimeSpan

class WiFiConnectionResult(_winrt.Object):
    ...
    connection_status: WiFiConnectionStatus

class WiFiNetworkReport(_winrt.Object):
    ...
    available_networks: winsdk.windows.foundation.collections.IVectorView[WiFiAvailableNetwork]
    timestamp: winsdk.windows.foundation.DateTime

class WiFiWpsConfigurationResult(_winrt.Object):
    ...
    status: WiFiWpsConfigurationStatus
    supported_wps_kinds: winsdk.windows.foundation.collections.IVectorView[WiFiWpsKind]

