# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.1

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

try:
    import winsdk.windows.storage.streams
except Exception:
    pass

try:
    import winsdk.windows.system
except Exception:
    pass

class GameSaveErrorStatus(enum.IntEnum):
    OK = 0
    ABORT = -2147467260
    INVALID_CONTAINER_NAME = -2138898431
    NO_ACCESS = -2138898430
    OUT_OF_LOCAL_STORAGE = -2138898429
    USER_CANCELED = -2138898428
    UPDATE_TOO_BIG = -2138898427
    QUOTA_EXCEEDED = -2138898426
    PROVIDED_BUFFER_TOO_SMALL = -2138898425
    BLOB_NOT_FOUND = -2138898424
    NO_XBOX_LIVE_INFO = -2138898423
    CONTAINER_NOT_IN_SYNC = -2138898422
    CONTAINER_SYNC_FAILED = -2138898421
    USER_HAS_NO_XBOX_LIVE_INFO = -2138898420
    OBJECT_EXPIRED = -2138898419

class GameSaveBlobGetResult(_winrt.Object):
    ...
    status: GameSaveErrorStatus
    value: winsdk.windows.foundation.collections.IMapView[str, winsdk.windows.storage.streams.IBuffer]

class GameSaveBlobInfo(_winrt.Object):
    ...
    name: str
    size: _winrt.UInt32

class GameSaveBlobInfoGetResult(_winrt.Object):
    ...
    status: GameSaveErrorStatus
    value: winsdk.windows.foundation.collections.IVectorView[GameSaveBlobInfo]

class GameSaveBlobInfoQuery(_winrt.Object):
    ...
    def get_blob_info_async() -> winsdk.windows.foundation.IAsyncOperation[GameSaveBlobInfoGetResult]:
        ...
    def get_blob_info_async(start_index: _winrt.UInt32, max_number_of_items: _winrt.UInt32) -> winsdk.windows.foundation.IAsyncOperation[GameSaveBlobInfoGetResult]:
        ...
    def get_item_count_async() -> winsdk.windows.foundation.IAsyncOperation[_winrt.UInt32]:
        ...

class GameSaveContainer(_winrt.Object):
    ...
    name: str
    provider: GameSaveProvider
    def create_blob_info_query(blob_name_prefix: str) -> GameSaveBlobInfoQuery:
        ...
    def get_async(blobs_to_read: typing.Iterable[str]) -> winsdk.windows.foundation.IAsyncOperation[GameSaveBlobGetResult]:
        ...
    def read_async(blobs_to_read: winsdk.windows.foundation.collections.IMapView[str, winsdk.windows.storage.streams.IBuffer]) -> winsdk.windows.foundation.IAsyncOperation[GameSaveOperationResult]:
        ...
    def submit_property_set_updates_async(blobs_to_write: winsdk.windows.foundation.collections.IPropertySet, blobs_to_delete: typing.Iterable[str], display_name: str) -> winsdk.windows.foundation.IAsyncOperation[GameSaveOperationResult]:
        ...
    def submit_updates_async(blobs_to_write: winsdk.windows.foundation.collections.IMapView[str, winsdk.windows.storage.streams.IBuffer], blobs_to_delete: typing.Iterable[str], display_name: str) -> winsdk.windows.foundation.IAsyncOperation[GameSaveOperationResult]:
        ...

class GameSaveContainerInfo(_winrt.Object):
    ...
    display_name: str
    last_modified_time: winsdk.windows.foundation.DateTime
    name: str
    needs_sync: _winrt.Boolean
    total_size: _winrt.UInt64

class GameSaveContainerInfoGetResult(_winrt.Object):
    ...
    status: GameSaveErrorStatus
    value: winsdk.windows.foundation.collections.IVectorView[GameSaveContainerInfo]

class GameSaveContainerInfoQuery(_winrt.Object):
    ...
    def get_container_info_async() -> winsdk.windows.foundation.IAsyncOperation[GameSaveContainerInfoGetResult]:
        ...
    def get_container_info_async(start_index: _winrt.UInt32, max_number_of_items: _winrt.UInt32) -> winsdk.windows.foundation.IAsyncOperation[GameSaveContainerInfoGetResult]:
        ...
    def get_item_count_async() -> winsdk.windows.foundation.IAsyncOperation[_winrt.UInt32]:
        ...

class GameSaveOperationResult(_winrt.Object):
    ...
    status: GameSaveErrorStatus

class GameSaveProvider(_winrt.Object):
    ...
    containers_changed_since_last_sync: winsdk.windows.foundation.collections.IVectorView[str]
    user: winsdk.windows.system.User
    def create_container(name: str) -> GameSaveContainer:
        ...
    def create_container_info_query() -> GameSaveContainerInfoQuery:
        ...
    def create_container_info_query(container_name_prefix: str) -> GameSaveContainerInfoQuery:
        ...
    def delete_container_async(name: str) -> winsdk.windows.foundation.IAsyncOperation[GameSaveOperationResult]:
        ...
    def get_for_user_async(user: winsdk.windows.system.User, service_config_id: str) -> winsdk.windows.foundation.IAsyncOperation[GameSaveProviderGetResult]:
        ...
    def get_remaining_bytes_in_quota_async() -> winsdk.windows.foundation.IAsyncOperation[_winrt.Int64]:
        ...
    def get_sync_on_demand_for_user_async(user: winsdk.windows.system.User, service_config_id: str) -> winsdk.windows.foundation.IAsyncOperation[GameSaveProviderGetResult]:
        ...

class GameSaveProviderGetResult(_winrt.Object):
    ...
    status: GameSaveErrorStatus
    value: GameSaveProvider

