# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.1

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

try:
    import winsdk.windows.security.cryptography.core
except Exception:
    pass

try:
    import winsdk.windows.storage.streams
except Exception:
    pass

try:
    import winsdk.windows.system
except Exception:
    pass

class KeyCredentialAttestationStatus(enum.IntEnum):
    SUCCESS = 0
    UNKNOWN_ERROR = 1
    NOT_SUPPORTED = 2
    TEMPORARY_FAILURE = 3

class KeyCredentialCreationOption(enum.IntEnum):
    REPLACE_EXISTING = 0
    FAIL_IF_EXISTS = 1

class KeyCredentialStatus(enum.IntEnum):
    SUCCESS = 0
    UNKNOWN_ERROR = 1
    NOT_FOUND = 2
    USER_CANCELED = 3
    USER_PREFERS_PASSWORD = 4
    CREDENTIAL_ALREADY_EXISTS = 5
    SECURITY_DEVICE_LOCKED = 6

class WebAccountPictureSize(enum.IntEnum):
    SIZE64X64 = 64
    SIZE208X208 = 208
    SIZE424X424 = 424
    SIZE1080X1080 = 1080

class WebAccountState(enum.IntEnum):
    NONE = 0
    CONNECTED = 1
    ERROR = 2

class KeyCredential(_winrt.Object):
    ...
    name: str
    def get_attestation_async() -> winsdk.windows.foundation.IAsyncOperation[KeyCredentialAttestationResult]:
        ...
    def request_sign_async(data: winsdk.windows.storage.streams.IBuffer) -> winsdk.windows.foundation.IAsyncOperation[KeyCredentialOperationResult]:
        ...
    def retrieve_public_key() -> winsdk.windows.storage.streams.IBuffer:
        ...
    def retrieve_public_key(blob_type: winsdk.windows.security.cryptography.core.CryptographicPublicKeyBlobType) -> winsdk.windows.storage.streams.IBuffer:
        ...

class KeyCredentialAttestationResult(_winrt.Object):
    ...
    attestation_buffer: winsdk.windows.storage.streams.IBuffer
    certificate_chain_buffer: winsdk.windows.storage.streams.IBuffer
    status: KeyCredentialAttestationStatus

class KeyCredentialManager(_winrt.Object):
    ...
    def delete_async(name: str) -> winsdk.windows.foundation.IAsyncAction:
        ...
    def is_supported_async() -> winsdk.windows.foundation.IAsyncOperation[_winrt.Boolean]:
        ...
    def open_async(name: str) -> winsdk.windows.foundation.IAsyncOperation[KeyCredentialRetrievalResult]:
        ...
    def renew_attestation_async() -> winsdk.windows.foundation.IAsyncAction:
        ...
    def request_create_async(name: str, option: KeyCredentialCreationOption) -> winsdk.windows.foundation.IAsyncOperation[KeyCredentialRetrievalResult]:
        ...

class KeyCredentialOperationResult(_winrt.Object):
    ...
    result: winsdk.windows.storage.streams.IBuffer
    status: KeyCredentialStatus

class KeyCredentialRetrievalResult(_winrt.Object):
    ...
    credential: KeyCredential
    status: KeyCredentialStatus

class PasswordCredential(_winrt.Object):
    ...
    user_name: str
    resource: str
    password: str
    properties: winsdk.windows.foundation.collections.IPropertySet
    def __init__(self, resource: str, user_name: str, password: str) -> None:
        ...
    def __init__(self, ) -> None:
        ...
    def retrieve_password() -> None:
        ...

class PasswordCredentialPropertyStore(winsdk.windows.foundation.collections.IPropertySet, winsdk.windows.foundation.collections.IObservableMap[str, _winrt.Object], winsdk.windows.foundation.collections.IMap[str, _winrt.Object], winsdk.windows.foundation.collections.IIterable[winsdk.windows.foundation.collections.IKeyValuePair[str, _winrt.Object]], _winrt.Object):
    ...
    size: _winrt.UInt32
    def __init__(self, ) -> None:
        ...
    def clear() -> None:
        ...
    def first() -> winsdk.windows.foundation.collections.IIterator[winsdk.windows.foundation.collections.IKeyValuePair[str, _winrt.Object]]:
        ...
    def get_view() -> winsdk.windows.foundation.collections.IMapView[str, _winrt.Object]:
        ...
    def has_key(key: str) -> _winrt.Boolean:
        ...
    def insert(key: str, value: _winrt.Object) -> _winrt.Boolean:
        ...
    def lookup(key: str) -> _winrt.Object:
        ...
    def remove(key: str) -> None:
        ...
    def add_map_changed(vhnd: winsdk.windows.foundation.collections.MapChangedEventHandler[str, _winrt.Object]) -> winsdk.windows.foundation.EventRegistrationToken:
        ...
    def remove_map_changed(token: winsdk.windows.foundation.EventRegistrationToken) -> None:
        ...

class PasswordVault(_winrt.Object):
    ...
    def __init__(self, ) -> None:
        ...
    def add(credential: PasswordCredential) -> None:
        ...
    def find_all_by_resource(resource: str) -> winsdk.windows.foundation.collections.IVectorView[PasswordCredential]:
        ...
    def find_all_by_user_name(user_name: str) -> winsdk.windows.foundation.collections.IVectorView[PasswordCredential]:
        ...
    def remove(credential: PasswordCredential) -> None:
        ...
    def retrieve(resource: str, user_name: str) -> PasswordCredential:
        ...
    def retrieve_all() -> winsdk.windows.foundation.collections.IVectorView[PasswordCredential]:
        ...

class WebAccount(IWebAccount, _winrt.Object):
    ...
    state: WebAccountState
    user_name: str
    web_account_provider: WebAccountProvider
    id: str
    properties: winsdk.windows.foundation.collections.IMapView[str, str]
    def __init__(self, web_account_provider: WebAccountProvider, user_name: str, state: WebAccountState) -> None:
        ...
    def get_picture_async(desized_size: WebAccountPictureSize) -> winsdk.windows.foundation.IAsyncOperation[winsdk.windows.storage.streams.IRandomAccessStream]:
        ...
    def sign_out_async() -> winsdk.windows.foundation.IAsyncAction:
        ...
    def sign_out_async(client_id: str) -> winsdk.windows.foundation.IAsyncAction:
        ...

class WebAccountProvider(_winrt.Object):
    ...
    display_name: str
    icon_uri: winsdk.windows.foundation.Uri
    id: str
    authority: str
    display_purpose: str
    user: winsdk.windows.system.User
    is_system_provider: _winrt.Boolean
    def __init__(self, id: str, display_name: str, icon_uri: winsdk.windows.foundation.Uri) -> None:
        ...

class IWebAccount(_winrt.Object):
    ...
    state: WebAccountState
    user_name: str
    web_account_provider: WebAccountProvider

